# AutolayoutPractice
✂️ SnapKit을 사용하여 인프런 iOS AutoLayout 강좌 실습

[🔗 인프런 강좌 링크 ](https://www.inflearn.com/course/autolayout/dashboard)

------
## 실습결과

| **계산기 레이아웃**<br />[CalculateViewController.swift](./AutolayoutPractice/CalculateViewController.swift) | **인증서 레이아웃**<br />[CertViewController.swift](./AutolayoutPractice/CertViewController.swift) | **커스텀 키보드**<br />[CustomKeyboardViewController](./AutolayoutPractice/CustomKeyboardViewController.swift) |
| :----------------------------------------------------------- | ------------------------------------------------------------ | ------------------------------------------------------------ |
| <img src="./images/calculator.png" alt="calculator" width=300/> | <img src="./images/cert.png" width=300>                      | <img src="./images/customKeyboard.png" width=300>            |
| - UIStackView <br />- StackView Constraint<br />- Corner Radius | - AutoShrink Font<br />- 비율에 따른 Constraint 적용         | - UIStackView<br />- Custom Keyboard <br />- Protocol        |



| **커스텀 스위치**<br />[CustomSwitchViewController.swift](./AutolayoutPractice/CustomSwitchViewController.swift) | **Expandable View**<br />[ExpandableViewController.swift](./AutolayoutPractice/ExpandableViewController.swift) | **플로팅 버튼**<br />[FloatingButtonViewController](./AutolayoutPractice/FloatingButtonViewController.swift) |
| :----------------------------------------------------------- | ------------------------------------------------------------ | ------------------------------------------------------------ |
| <img src="./images/switch.GIF" width=300>                    | <img src="./images/expandable.GIF" width=300>                | <img src="./images/floating.gif" width=300>                  |
| - Update Constraint<br />- Corner Radius<br />- UIView Animation | - UITableView<br />- UIView Animation<br />- Reload TableView Data | - Update Constraint<br />- UIView Animation<br />- Blur Effect |



| **그래프**<br />[GraphViewController.swift](./AutolayoutPractice/GraphViewController.swift) | **다각형 커스텀 뷰**<br />[DiagonalViewController.swift](./AutolayoutPractice/DiagonalViewController.swift) | **팝업**<br />[PopUpViewController](./AutolayoutPractice/PopUpViewController.swift) |
| :----------------------------------------------------------- | ------------------------------------------------------------ | ------------------------------------------------------------ |
| <img src="./images/graph.gif" width=300>                     | <img src="./images/diagonal.jpeg" width=300>                 | <img src="./images/popup.gif" width=300>                     |
| - Update Constraint<br />- UIView Animation                  | - BezierPath<br />- CAShapeLayer                             | - Align Constraint<br />- PresentationStyle / TransitionStyle<br /> |

| **로그인 레이아웃**<br />[SignInViewController.swift](./AutolayoutPractice/SignInViewController.swift) | **채팅 레이아웃**<br />[ChatViewController.swift](./AutolayoutPractice/ChatViewController.swift) |
| :----------------------------------------------------------- | ------------------------------------------------------------ |
| <img src="./images/signin.gif" width=300>                    | <img src="./images/chat.gif" width=300>                      |
| - Update Constraint<br />- 정규식<br />- addTarget Method    | - UITableView<br />- Image Stretch<br />- Notification<br />- Keyboard Dismiss |

